import eg
import urllib,re,thread

eg.RegisterPlugin(
    name = "HALX",
    author = "Jitterjames",
    version = "0.2.1",
    kind = "other",
    canMultiLoad = True,
    createMacrosOnAdd = True,
    description = (
        'Adds actions to learn codes and control devices with '
        '<a href="http://halx.co.uk">'
        'HALX</a> home automation controller.'
    ),
    help = """
        Online help:
        <a href=http://voxcommando.com/forum/index.php?topic=846.0/>Support on VoxCommando Website</a><BR/><BR/>
		
		More information about HALX:<BR/>
        <a href=http://halx.co.uk/>HALX Website</a>
        
        <BR><img src="http://halx.co.uk/skins/sport/customer/images/halx-logo-red.jpg">
    """,
    icon = (
        """iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJ
bWFnZVJlYWR5ccllPAAAAeNJREFUeNqMUz9oGmEU/33nRbn4t1YJoSAuoXQrpGvGTKXQditmabea
0TGiCK6OoXRJF0nHBkpHhxA6CBkKHboUBDuIRIn21PPOf33v885orpI8+PHeve+93/e9PydyuRyE
EC8AbOP+0pjNZl8LhQLUyWTCjkfFYvEDOe/MpMuQzWbfO9/qaDSS/vF4jFqtdidBMpkE5QgXAetU
KiWdB8+foPztl0uzVCqVFQLFNE0QFMuyoGkaAoEA9p9Fpb2s2c92p9OR8ZwnX2AbksDv98Pn8+Hs
/A/C4bBLc2y3+1cSLEpwCLiZwWBQ3vS7DcTjWNHRKNDr9Th0lWA4HC4IQqEQIpHI2gYqikJTUEE5
bgLTFMjnS9JZKuURi8UWia1WC5lMQdq63vkvAXVVxWAwkE7uBb/GEcMwFmcej5cJbsZYrVaRSCRo
Pzx0OCdOp49czzeM/s0aNhqiXq/DvhkPqHkvqb6tWzkb1KynNJUfZI+WD6bTaVPX9TPa3Gsm0Gz4
bEJHHhI+Ed4S2kt+3ncenUEExvqdPY1/xOvNS6nXCP87Kmlu92PCro0dghenPbw6ebP75d1njr10
yrft74SfhKaQwfMSgjY0Wcrh5gHiYg9XswscD8o2gcWTJHQJfXqB9U+AAQDt2d7dple4RwAAAABJ
RU5ErkJggg=="""
    ),
    url = "http://halx.co.uk"
)



eg.RegisterPlugin()


class HALX(eg.PluginBase):

    class text:
        labelHost = "HALX Address:"
        labelUsername = "HALX Username:"
        labelPassword = "HALX Password:"

            
    def Configure(self, host="HALX",username="",password=""):
        panel = eg.ConfigPanel()
        textLabel1 = wx.StaticText(panel, -1, self.text.labelHost)
        textBx_Code = wx.TextCtrl(panel, -1, host, size = (200,-1))
        panel.sizer.Add(textLabel1, 0, wx.TOP, 20)
        panel.sizer.Add(textBx_Code, 0, wx.TOP, 3)
        
        textLabel2 = wx.StaticText(panel, -1, self.text.labelUsername)
        textBx_2 = wx.TextCtrl(panel, -1, username, size = (200,-1))
        panel.sizer.Add(textLabel2, 0, wx.TOP, 20)
        panel.sizer.Add(textBx_2, 0, wx.TOP, 3)
        
        textLabel3 = wx.StaticText(panel, -1, self.text.labelPassword)
        textBx_3 = wx.TextCtrl(panel, -1, password, size = (200,-1))
        panel.sizer.Add(textLabel3, 0, wx.TOP, 20)
        panel.sizer.Add(textBx_3, 0, wx.TOP, 3)
        while panel.Affirmed():
            panel.SetResult(textBx_Code.GetValue(),textBx_2.GetValue(),textBx_3.GetValue())
            
            
            
    def __init__(self):
        self.counter = 0
        self.AddAction(Send)
        

    def __start__(self,  thisHost, thisUser, thisPass):
        self.hostAddr = thisHost.rstrip("/").lstrip("http://")+"/"
        self.userName = thisUser
        self.password = thisPass


        
        
class Send(eg.ActionBase):
    class text:
        labelCode = "Code:"
        labelLearn = "Learn:"
        labelFriendlyName = "Name:"
        labelFriendlyName2 = "(only for identification)"

    def __call__(self, fname, myCode):
        #print myCode
        myURL = "http://"+self.plugin.userName+":"+self.plugin.password+"@"+self.plugin.hostAddr+myCode
        #print myURL
        thread.start_new_thread(urllib.urlopen,(myURL,))
        
    def Configure(self,fname="", mycode=""):
        panel = eg.ConfigPanel()
        
        textBx_fname = wx.TextCtrl(panel, -1, fname, size = (200,-1))                
        textBx_Code = wx.TextCtrl(panel, -1, mycode, size = (200,-1))        
        
        learnIrButton = wx.Button(panel,-1,"IR",size = (30,-1))
        learnRfButton = wx.Button(panel,-1,"RF",size = (30,-1))
        
        #define sizers
        optionsSizer1 = wx.GridBagSizer(0, 5)
        optionsSizer2 = wx.GridBagSizer(0, 5)

        #sizer1 name
        optionsSizer1.Add(wx.StaticText(panel, -1, self.text.labelFriendlyName), (0, 0),  flag = wx.ALIGN_CENTER_VERTICAL)        
        optionsSizer1.Add(textBx_fname, (1, 0), (1, 1), flag = wx.EXPAND)
        optionsSizer1.Add(wx.StaticText(panel, -1, self.text.labelFriendlyName2), (1, 2),  flag = wx.ALIGN_CENTER_VERTICAL)        

        #learn code
        optionsSizer2.Add(wx.StaticText(panel, -1, self.text.labelCode), (0, 0),  flag = wx.ALIGN_CENTER_VERTICAL)
        optionsSizer2.Add(wx.StaticText(panel, -1, self.text.labelLearn), (0, 2),  flag = wx.ALIGN_CENTER_VERTICAL)
        optionsSizer2.Add(textBx_Code, (1, 0), (1, 1), flag = wx.EXPAND)
        optionsSizer2.Add(learnIrButton, (1, 2), (1, 1), flag = wx.EXPAND)
        optionsSizer2.Add(learnRfButton, (1, 3), (1, 1), flag = wx.EXPAND)
        
        #add the options sizers
        panel.sizer.Add(optionsSizer1, 0, wx.TOP, 10)
        panel.sizer.Add(optionsSizer2, 0, wx.TOP, 20)
        


        def LearnIR(event):
            myURL = "http://"+self.plugin.userName+":"+self.plugin.password+"@"+self.plugin.hostAddr+"irdecode.htm"
            u = urllib.urlopen(myURL, data=urllib.urlencode({'submit': 'Get IR'})) 
            doc =u.read()
            match = re.search("id=\"code.*?http://.*?/(.*?)\n", doc, re.I| re.S)
            u.close()
            code = match.group(1)
            if not code is None:
                textBx_Code.SetValue(code)
        learnIrButton.Bind(wx.EVT_BUTTON, LearnIR)


        def LearnRF(event):
            myURL = "http://"+self.plugin.userName+":"+self.plugin.password+"@"+self.plugin.hostAddr+"rfdecode.htm"
            u = urllib.urlopen(myURL, data=urllib.urlencode({'submit': 'Get IR'})) 
            doc =u.read()
            match = re.search("id=\"code.*?http://.*?/(.*?)</div", doc, re.I| re.S)
            u.close()
            code = match.group(1)
            if not code is None:
                textBx_Code.SetValue(code)
        learnRfButton.Bind(wx.EVT_BUTTON, LearnRF)



				
        while panel.Affirmed():
            panel.SetResult(textBx_fname.GetValue(),textBx_Code.GetValue())

            
